﻿; ------------------------------------------------------------------------------------
; Stack Machine - Binärformat
; PB 4.5+ OS: Windows/Linux/MacOS Architecture: x86/x64
; Author: Alexander Aigner, cxAlex @ purebasic.fr/german
; ------------------------------------------------------------------------------------

; OpCode
Structure OpCode
  OpCode.a ; OpCode
  Value.l ; Value
EndStructure

; Op-Codes
Enumeration 0
  ; Spezial-Codes:
  #OP_Stop
  #OP_VAR
  ; IO - Opcodes:
  #OP_IN
  #OP_OUT
  #OP_IOPTU
  #OP_IOPTD
  ; Werden vom Prozessor ausgeführt
  #OP_LDAU
  #OP_LDAD
  #OP_STAD
  #OP_LEA
  #OP_ADDU
  #OP_ADDD
  #OP_SUBU
  #OP_SUBD
  #OP_MULU
  #OP_MULD
  #OP_DIVU
  #OP_DIVD
  #OP_MODU
  #OP_MODD
  #OP_ANDU
  #OP_ANDD
  #OP_ORU
  #OP_ORD
  #OP_XORU
  #OP_XORD
  #OP_NOT
  #OP_SHLU
  #OP_SHLD
  #OP_SHRU
  #OP_SHRD
  #OP_CMPU
  #OP_CMPD
  #OP_JMP
  #OP_JP
  #OP_JNP
  #OP_JN
  #OP_JNN
  #OP_JZ
  #OP_JNZ
  #OP_IF
  #OP_IFN
  #OP_CALL
  #OP_RET
  #OP_RETN
  #OP_NEWB
  #OP_OLDB
  #OP_RES
  #OP_Red
  #OP_PUSH
  #OP_POP
  #OP_STL
  #OP_LDL
  #OP_ADL
  #OP_SBL
  #OP_CPL
  #OP_STLI
  #OP_LDLI
  #OP_ADLI
  #OP_SBLI
  #OP_CPLI
EndEnumeration


; IDE Options = PureBasic 4.60 Beta 3 (Windows - x64)
; CursorPosition = 21
; EnableXP
; CPU = 1